
#include "Stack.h"
#include "error.h"

Stack::Stack(int s = 100) : size(0), capacity(s)
{
  elem = new (void*)[s];
}


Stack::~Stack()
{
  delete [] elem;
}


void Stack::push(void *obj)
{
  if(size == capacity)
    error(0, "Stack full");
  elem[size++] = obj;
}


void *Stack::pop()
{
  if(size == 0)
    error(0, "Stack empty");
  return elem[--size];
}


void *Stack::peek()
{
  if(size == 0)
    error(0, "Stack empty");
  return elem[size - 1];
}
