

void exec_repeat()
{
  nextToken();
  stack.push(new RepeatFrame(lineno));
}


void exec_until()
{
  nextToken();  // skip UNTIL
  Frame top = stack.peek();
  if(!(top instanceof RepeatFrame))
    error(1, "REPEAT without UNTIL");
  if(float_expression() == 0)
    goto_line(top.lineno);
  else
    stack.pop();
}


class NewFrame
{
  Object *for_var;
  float for_limit;
  float for_step;
  int lineno;
}


void exec_for()
{
  nextToken();
  if(ttype != TT_IDENTIFIER)
    error(1, "Identifier expexted after FOR");
  if(isString(sval))
    error(6, "Type mismatch: numeric variable needed");
  for_var = symbols.lookup_or_create(sval);
  nextToken();
  expect('=', 1, "Missing = in FOR statement");
  assign(for_var, numeric_expression());
  expect(TT_TO, 1, "Missing TO");
  for_limit = float_expression();
  if(ttype == TT_STEP) {
    nextToken();
    // distinguish between int and float...
    for_step = float_expression();
  }
  else
    for_step = 1;

  stack.push(new NextFrame(for_var, for_limit, for_step, lineno);
}


void exec_next()
{
  nextToken();
  Frame top = stack.peek();
  if(!(top instanceof RepeatFrame))
    error(1, "NEXT without FOR");

  // for_var points to the loop variable

  if(for_var->isInteger())
    for_var->intValue += (int) top.for_step;
  else
    for_var->floatValue += top.for_step;
  assign(top.for_var, &val);
  if(for_var->toFloat() <= top.for_limit)
    goto_line(top.lineno);
  else
    stack.pop();
}

